;                            "Vaudeville Intro 2017 remake"
;                                    done in 2017
;
;           Code, music and charsets by Sylwester (Buddha) Hasiak
;           Logo by Bladee
;           NTSC fix by Karmic
;
;     Use lastest 64TASS improved by Soci/Singular crossassembler to compile it
;                                                 
;-------------------------------
;       Start intro from BASIC
;-------------------------------
;.comment 
		*= $0801
        .word sys,2017
        .null $9e,^main
sys     .word 0
							
;.endc	
;---------------------------------------------
;       Intro initialisations
;---------------------------------------------
;music load in memory range from $1000 to $1fff
initm = $1000 ;  < ------- music init address
playm = $1003 ;  < ------- music play address
;----------------------------------------------
pcname = $4900
        * = $5000                                    ; < ------------ intro start address
main    sei

        lda $d012 ;test NTSC/PAL
        cmp $d012
        beq *-3
        bmi *-8
        cmp #$37
        beq notntsc
        lda #<ntscply
        sta ntsc1+1
        lda #>ntscply
        sta ntsc1+2
        lda #$f8
        sta ntsc2+1
notntsc lda #$00
        tax 
-       sta $0800,x
        sta $0840,x
        sta $0c00,x
        sta $0c40,x
        inx 
        bne -
        ldx #$00
- 	    txa 
 		clc
 		adc #$80
        sta pcname,x
        inx 
        cpx #$50
        bcc -
        jsr setpcname
		jsr downc
        ldx #$00
-       lda $4000,x
        sta $d800,x
        lda $4100,x
        sta $d900,x
        lda $4200,x
        sta $da00,x
        lda $4400,x
        sta $0400,x
        lda $4500,x
        sta $0500,x
        lda $4600,x
        sta $0600,x
        inx
        bne -
        ldx #$00
- 	    txa 
        sta $05b8,x
        inx 
        cpx #$28
        bcc -
;------------------------------------
;       Initialise IRQ and music
;------------------------------------
        lda #$7f
        sta $dc0d
        lda $dc0d
        lda #1
        sta $d01a    
        lda #$1b
        sta $d011    
        lda #$32
        sta $d012
        lda $dd00
        and #%11111100
        ora #%00000011
        sta $dd00
		lda #<irq1
        ldx #>irq1
        sta $0314
        stx $0315 
        lda #0                             ; < ---------- select subsong in player music
        jsr initm   
        cli
this    jsr space
        jmp this
;--------------------------------------
;       Enter IRQ
;--------------------------------------
irq1	inc $d019
        lda #$3b
        sta $d011
		lda #(($2000 >> 10) & $0f) | (($0400 >> 6) & $f0)
		sta $d018
		lda #$d8
		sta $d016
        lda #$00
        sta $d020
        lda #$00
        sta $d021
ntsc1   jsr playm

        lda #$86
        sta $d012
        lda #<irq2
        sta $0314
        lda #>irq2
        sta $0315
        jmp $ea81
irq2	inc $d019
        ldx #$03
-       dex
        bne -
        lda #$01
        sta $d020
        sta $d021
        ldx #$0a
-       dex
        bne -
        nop
        nop
        lda #$00
        sta $d020
        sta $d021
        ldx #$21
-       dex
        bne -
        lda #$1b
        sta $d011
		lda #(($0800 >> 10) & $0f) | (($0400 >> 6) & $f0)
		sta $d018
		lda pfpos
		sta $d016
        ldx #$58
-       dex
        bne -
        lda #$3b
        sta $d011
		lda #(($2000 >> 10) & $0f) | (($0400 >> 6) & $f0)
		sta $d018
		lda #$d8
		sta $d016
        lda #$00
        sta $d021
        lda #$95
        sta $d012
        lda #<irq4
        sta $0314
        lda #>irq4
        sta $0315
        jmp $ea81
irq4    inc $d019
        ldx #$03
-       dex
        bne -
        lda #$01
        sta $d020
        sta $d021
        ldx #$16
-       dex
        bne -
        lda #$00
        sta $d020
        sta $d021
        ldx #$22
-       dex
        bne -
        lda #$1b
        sta $d011
		lda #(($0800 >> 10) & $0f) | (($0400 >> 6) & $f0)
		sta $d018
		lda scpos
		sta $d016
        ldx #$58
-       dex
        bne -
        bit $eaea
        lda #$3b
        sta $d011
		lda #(($2000 >> 10) & $0f) | (($0400 >> 6) & $f0)
		sta $d018
		lda #$d8
		sta $d016
        lda #$00
        sta $d021
ntsc2   lda #$a5
        sta $d012
        lda #<irq5
        sta $0314
        lda #>irq5
        sta $0315
        jmp $ea81
irq5    inc $d019
        ldx #$03
-       dex
        bne -
        lda #$01
        sta $d020
        sta $d021
        ldx #$0b
-       dex
        bne -
        lda #$00
        sta $d020
        sta $d021
        lda #$32
        sta $d012
        lda #<irq1
        sta $0314
        lda #>irq1
        sta $0315
        jsr cnmov
        jsr movcol
        jsr pscroll
        jsr scrlcol
		jsr clrcnr
dtr		lda $4f00
		sta speed
		inc dtr+1
		lda dtr+1
		cmp #$20
		bne +
		lda #0
		sta dtr+1
		
+       jmp $ea81
clrcnr  lda pline9      
		cmp #$80 
		bne check
		lda #$00
		sta check+1
check	lda clrcntab+$80
		sta colorn
		lda check+1
        cmp #$80
        bne +
endclr	rts
+		inc check+1
		rts
scrlcol ldx #$00
-		lda $d9b9,x
		sta $d9b8,x
		inx
		cpx #$28
		bne -
scx		lda cncol1
		sta $d9df
		inc scx+1
		rts
cnmov   
        ldx cn1pos
        lda cnsin,x
        pha 
        and #$07
        eor #$07
        sta scpos
        pla 
        lsr 
        lsr 
        lsr 
        tay 
        ldx #$00
-       lda pcname,y
        sta $0608,x
        inx 
        iny 
        cpx #$28
        bne -
        inc cn1pos
        rts 
movcol  ldx #$00
add		lda cncol
-		sta $da08,x
		inx
		cpx #$28
		bne -
		inc add+1
		lda add+1
		cmp #$f0
		bne +
		lda #0
		sta add+1
+		rts
pscroll
	    lda pline9
        beq +
        dec pline9
        rts 

+	    lda pfpos
        sec 
speed   =*+$01
        sbc #$01
        sta pfpos
        bmi +
        rts 
+	    clc 
        adc #$08
        sta pfpos
        ldx #$00
        ldy $05b8
-	    lda $05b9,x
        sta $05b8,x
        inx 
        cpx #$27
        bcc -
        sty $05df
        cpy #$00
        bne +
        lda #$00
        ldx #$08
        bne ++
+       lda addb1
        ldx addb2
        clc 
        adc #$08
        bcc +
        inx 
+	    sta addb1
        sta addd1
        sta addc1
        stx addb2
        stx addd2
        stx addc2
        ldy #$07
-	    lda pline1,y
addb1   =*+$01
addb2   =*+$02
        sta $0800,y
        dey 
        bpl -
        lda pline0
        bne next1
        ldx #$07
-	    cmp pline1,x
        bne next2
        dex 
        bpl -
add1   =*+$01
add2   =*+$02
next1   lda scroll
        cmp #$ff
        bne +
        lda #<scroll
        sta add1
        lda #>scroll
        sta add2 
        bne next1
next2   sta pline1,x
        dex 
        bpl next2
        rts 
+	    inc add1
        bne +
        inc add2
+       cmp #$80
        bcc ++
        and #$07
        beq +
        sta speed
        bne next1
+	    lda #$80
        sta pline9
        bne next1
+	    sta pline10
        tax 
        ldy copypf,x
        sty adde2
        asl 
        asl 
        asl 
        sta adde1
        ldy #$07
adde1   =*+$01
adde2   =*+$02
-	    lda fpf,y
        ldx #$00
        stx pline11
        ldx pline0
        beq +
-	    lsr 
        ror pline11
        dex 
        bne -
addd1   =*+$01
addd2   =*+$02
        ora $0800,y
addc1   =*+$01
addc2   =*+$02
+	    sta $0800,y
        lda pline11
        sta pline1,y
        dey 
        bpl --
        ldx pline10
        lda pline0
        clc 
        adc sizepf,x
        cmp #$08
        and #$07
        sta pline0
        bcc next1
        rts 
pline0   .byte $00
pline1	.byte $00
pline2	.byte $00
pline3	.byte $00
pline4	.byte $00
pline5	.byte $00
pline6	.byte $00
pline7	.byte $00
pline8	.byte $00
pline9	.byte $00
pline10	.byte $00
pline11	.byte $00
;-------------------------------------------------
;       D800, D020, D021 color screen Fader
;-------------------------------------------------
downc   lda #$10
        sta $ff
down1   ldx #5
        jsr waitx
        lda $d020
        and #$0f
        tax 
        lda dcolor,x
        sta $d020
        lda $d021
        and #$0f
        tax 
        lda dcolor,x
        sta $d021
        ldy #$00
        ldx #$d7
down2   inx 
        stx down3
        stx down5
down3   =*+$02
down4   lda $d800,y
        and #$0f
        tax 
        lda dcolor,x
down5   =*+$02
        sta $d800,y
        iny 
        bne down4
        ldx down3
        cpx #$db
        bne down2
        dec $ff
        bne down1
        rts
;--------------------------------------
;       Delay synchronisation
;--------------------------------------
wait1   lda #$fb
        ldy #0
do1     iny 
        bne do1
        clc 
        adc #1
        bne do1
        rts 
waitx   jsr wait1
        dex 
        bpl waitx
        rts 
;ntsc play
ntscply dec ntsccnt
        bne +
        lda #6
        sta ntsccnt
        rts
+       jmp playm
ntsccnt .byte 6
        ;---------
        
;--------------------------------------------
;       Cracked game name and scroll text
;--------------------------------------------
.enc screen

cname   .text "                                                               * Vaudeville Intro 2017 remake *                                                      "
		.byte $ff
;                                                   SCROLL TEXT                  
scroll  .text "                    Vaudeville is back in 2017 with Hokuto Force remake intro                                     "
		.text "   .....    Code, charsets and music by Buddha, Logo by Bladee, NTSC fix by Karmic .........                           "
        .text "                     Buddha on da keys:                      It's remake of Hokuto Force intro, where I was a half ripped logo from Cadgers because I only learning from it ! .......             Now is original VDV logo by Bladee (Thanks dude!) .                      I'm not a graphician and has become so because during Genesis Project party, none of the HF graphicians did not have time to draw a HF logo, so I had something to combine !                      Greetings from Buddha to my always best friends and is same as from P3ysOn                         :)          ;)             :)      "
        .text "          P3ys0n on da keys:             ...         Greetings from me and Buddha to best friends        V-12 * Hank * Archibald * Cobra * Volcano * Kyno * Blemish * Algorithm * Cash * Buddha * Dr.Brooks * Br0da * Plama * Klax * Bober * Nemezis * J.F.Kennedee * Colitt * Bladee * Fenek * Wacek * Centrax * JSL * Jericho * Sebaloz * Flea * Krugi * Gohanks * Dane * Nitro * Creator * Ser * Voyager * Jailbird * Crayon * Bimber and for all ZX SPECTRUM, C64, ATARI PC and AMIGA scene  ...                          Big fucks from P3ys0n to MAGNATE/OBSESSION about impersonating me ...and CJ WARLOCK & DR.GUMA...                                             "
		.text "                   Press space to exit!                                   "
        .byte $ff        
;----------------------------------------------------------------
crdts1  .text "  Intro credits :                       "
crdts2  .text "  Code,fonts & music by Buddha          "
crdts3  .text "  Logo by Bladee                        "
crdts4  .text "  NTSC Fix by Karmic                    "
;----------------------------------------------------------------
;   Preview of trainer menu in intro but I code it in future
;
;train1  .text "      Cracked by Buddha/Vaudeville     "
;train2  .text " Ulimited lives ?          Yes/No      "
;train3  .text " Ulimited time ?           Yes/No      "
;train5  .text " load HS saves ?           Yes/No      "
;train4  .text " See end sequence now ?    Yes/No      "
;----------------------------------------------------------------
;   Special notes area or fill it with space key for unvisible
note1	 .text "Special greetings from Buddha to my best"
note2	 .text "        computer scene friends :        "
note3	 .text "    P3ys0n/Vaudeville, V-12/Tropyx      "
note4	 .text "Jammer/MSL,RAF/Vulture,Rock/Finish Gold "
note5	 .text "      Greetings for all my friends      "
.enc none
;--------------------------------------------
;           Cracked game relocations 
;--------------------------------------------
space   lda $dc01
        cmp #$ef
        beq end
        rts
end     sei 
        jsr $fda3           
        jsr $fd15    
        jsr $ff5b     
		lda #$00
		sta $d020
		sta $d021
        ldx #0
        lda #0
-       sta $d400,x
        inx
        cpx #$50
        bne -
        lda #$17
		sta $d018
		jsr credits
        ldx #$00
-	  	lda reloc,x
        sta $0340,x 
        inx 
        cpx #$50
        bne -
        cli 
        jmp $0340

reloc   sei 
        lda #$34
        sta $01
-	    ldx #$00
-	    lda crkgame,x
        sta $0801,x
        inx 
        bne -
        inc $0349
        inc $034c
        lda $0349
        cmp #$00
        bne --
        lda #$37
        sta $01
        cli 
        jmp $fce2 ;       ----->   Cracked game start address
credits ldx #0
-       lda crdts1,x
        sta $0400,x
        lda #0
        sta $d800,x
        lda crdts2,x
        sta $0450,x
        lda #0
        sta $d850,x
        lda crdts3,x
        sta $0478,x
        lda #0
        sta $d878,x
        lda crdts4,x
        sta $04a0,x
        lda #0
        sta $d8a0,x
        inx
        cpx #$28
        bne -
        ldx #0
-       lda note1,x
        sta $06d0,x
        lda #0
        sta $dad0,x
        lda note2,x
        sta $06f8,x
        lda #0
        sta $daf8,x
        lda note3,x
        sta $0720,x
        lda #0
        sta $db20,x
        lda note4,x
        sta $0748,x
        lda #0
        sta $db48,x
        lda note5,x
        sta $0798,x
        lda #0
        sta $db98,x
        inx
        cpx #$28
        bne -
xx0     ldx #5
        jsr waitx
        ldx #0
xx1     lda crdtsc
-       sta $d800,x
        inx
        cpx #$28
        bne -
        inc xx1+1
        lda xx1+1
        cmp #$10
        bne +
        jmp ax0
+       jmp xx0 
ax0     ldx #5
        jsr waitx
        ldx #0
ax1     lda crdtsc
-       sta $d850,x
        inx
        cpx #$28
        bne -
        inc ax1+1
        lda ax1+1
        cmp #$10
        bne +
        jmp bx0
+       jmp ax0
bx0     ldx #5
        jsr waitx
        ldx #0
bx1     lda crdtsc
-       sta $d878,x
        inx
        cpx #$28
        bne -
        inc bx1+1
        lda bx1+1
        cmp #$10
        bne +
        jmp cx0
+       jmp bx0
cx0     ldx #5
        jsr waitx
        ldx #0
cx1     lda crdtsc
-       sta $d8a0,x
        inx
        cpx #$28
        bne -
        inc cx1+1
        lda cx1+1
        cmp #$10
        bne +
        jmp dx0
+       jmp cx0
dx0     ldx #5
        jsr waitx
        ldx #0
dx1     lda crdtsc
-       sta $dad0,x
        inx
        cpx #$28
        bne -
        inc dx1+1
        lda dx1+1
        cmp #$10
        bne +
        jmp ex0
+       jmp dx0
ex0     ldx #5
        jsr waitx
        ldx #0
ex1     lda crdtsc
-       sta $daf8,x
        inx
        cpx #$28
        bne -
        inc ex1+1
        lda ex1+1
        cmp #$10
        bne +
        jmp fx0
+       jmp ex0
fx0     ldx #5
        jsr waitx
        ldx #0
fx1     lda crdtsc
-       sta $db20,x
        inx
        cpx #$28
        bne -
        inc fx1+1
        lda fx1+1
        cmp #$10
        bne +
        jmp gx0
+       jmp fx0
gx0     ldx #5
        jsr waitx
        ldx #0
gx1     lda crdtsc
-       sta $db48,x
        inx
        cpx #$28
        bne -
        inc gx1+1
        lda gx1+1
        cmp #$10
        bne +
        jmp hx0
+       jmp gx0
hx0     ldx #5
        jsr waitx
        ldx #0
hx1     lda crdtsc
-       sta $db98,x
        inx
        cpx #$28
        bne -
        inc hx1+1
        lda hx1+1
        cmp #$10
        bne +
        jmp crdend
+       jmp hx0
crdend  ldx #$f0
        jmp waitx

dcolor  .byte $00,$0d,$09,$0f,$08,$0c,$00,$03
        .byte $0b,$06,$05,$02,$0e,$07,$04,$0a

colorn .byte $00
cn1pos  .byte $00
;cn3pos  .byte $00
;cn4pos  .byte $00
pfpos   .byte $00
scpos   .byte $00

sizepf
        .BYTE $05,$06,$06,$06,$06,$06,$06,$06
        .BYTE $06,$03,$04,$06,$04,$09,$06,$06
        .BYTE $06,$06,$06,$06,$04,$06,$06,$09
        .BYTE $06,$06,$06,$05,$07,$05,$07,$08
        .BYTE $03,$03,$06,$08,$08,$07,$07,$04
        .BYTE $05,$05,$06,$07,$04,$06,$03,$06
        .BYTE $07,$04,$07,$07,$06,$07,$07,$07
        .BYTE $07,$07,$03,$04,$05,$06,$05,$07
        .BYTE $05,$07,$07,$07,$07,$07,$07,$07
        .BYTE $07,$03,$07,$07,$07,$09,$07,$07
        .BYTE $07,$07,$07,$07,$07,$07,$07,$09
        .BYTE $07,$07,$07,$08,$08,$08,$08,$08
        .BYTE $09,$08,$08,$08,$08,$08,$08,$08

copypf
        .byte >fpf,>fpf,>fpf,>fpf,>fpf,>fpf,>fpf,>fpf
        .byte >fpf,>fpf,>fpf,>fpf,>fpf,>fpf,>fpf,>fpf
        .byte >fpf,>fpf,>fpf,>fpf,>fpf,>fpf,>fpf,>fpf
        .byte >fpf,>fpf,>fpf,>fpf,>fpf,>fpf,>fpf,>fpf
        .byte >fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100
        .byte >fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100
        .byte >fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100
        .byte >fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100,>fpf+$100
        .byte >fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200
        .byte >fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200
        .byte >fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200
        .byte >fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200,>fpf+$200
        .byte >fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300
        .byte >fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300
        .byte >fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300
        .byte >fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300,>fpf+$300

setpcname 
		lda #$00
        ldx #$0c
        bne +
new     lda addb11
        ldx addb21
        clc 
        adc #$08
        bcc +
        inx 
+	    sta addb11
        sta addd11
        sta addc11
        stx addb21
        stx addd21
        stx addc21
        ldy #$07
-	    lda pline11a,y
addb11   =*+$01
addb21   =*+$02
        sta $0800,y
        dey 
        bpl -
        lda pline01
        bne next11
        ldx #$07
-	    cmp pline11a,x
        bne next21
        dex 
        bpl -
add11   =*+$01
add21   =*+$02
next11   lda cname
        cmp #$ff
        bne +
        rts
next21   sta pline11a,x
        dex 
        bpl next21
        jmp new 
+	    inc add11
        bne +
        inc add21

+	    sta pline101
        tax 
        ldy copypf,x
        sty adde21
        asl 
        asl 
        asl 
        sta adde11
        ldy #$07
adde11   =*+$01
adde21   =*+$02
-	    lda fpf,y
        ldx #$00
        stx pline111
        ldx pline01
        beq +
-	    lsr 
        ror pline111
        dex 
        bne -
addd11   =*+$01
addd21   =*+$02
        ora $0800,y
addc11   =*+$01
addc21   =*+$02
+	    sta $0800,y
        lda pline111
        sta pline11a,y
        dey 
        bpl --
        ldx pline101
        lda pline01
        clc 
        adc sizepf,x
        cmp #$08
        and #$07
        sta pline01
        bcc next11
        jmp new 
pline01   .byte $00
pline11a	.byte $00
pline21	.byte $00
pline31	.byte $00
pline41	.byte $00
pline51	.byte $00
pline61	.byte $00
pline71	.byte $00
pline81	.byte $00
pline91	.byte $00
pline101	.byte $00
pline111	.byte $00
crkgame 	
;		.binary "filename.prg",2              ; <---------  put cracked game here
		.byte $00
;--------------------------------------------
;      Some binaries and inludes to C64 RAM
;--------------------------------------------
*= $4c00
.include "pfonts1x1bybotx.txt"
*= $2000
.binary "rbitmap.prg",2
*= $4400
.binary "lscreen1.prg",2
*= $4000
.binary "lcolor1.prg",2
* = $1000                                     ; < ------- music load address
.binary "verti.prg",2
* = $0a00
cnsin   .byte $7c,$79,$76,$73,$70,$6d,$6a,$67
        .byte $63,$60,$5d,$5a,$57,$54,$51,$4f
        .byte $4c,$49,$46,$43,$40,$3e,$3b,$38
        .byte $36,$33,$31,$2e,$2c,$2a,$27,$25
        .byte $23,$21,$1f,$1d,$1b,$19,$17,$15
        .byte $13,$12,$10,$0f,$0d,$0c,$0a,$09
        .byte $08,$07,$06,$05,$04,$03,$03,$02
        .byte $01,$01,$00,$00,$00,$00,$00,$00
        .byte $00,$00,$00,$00,$00,$01,$01,$02
        .byte $03,$03,$04,$05,$06,$07,$08,$09
        .byte $0a,$0c,$0d,$0f,$10,$12,$13,$15
        .byte $17,$19,$1b,$1d,$1f,$21,$23,$25
        .byte $27,$2a,$2c,$2e,$31,$33,$36,$38
        .byte $3b,$3e,$40,$43,$46,$49,$4c,$4f
        .byte $51,$54,$57,$5a,$5d,$60,$63,$67
        .byte $6a,$6d,$70,$73,$76,$79,$7c,$80
        .byte $83,$86,$89,$8c,$8f,$92,$95,$98
        .byte $9c,$9f,$a2,$a5,$a8,$ab,$ae,$b0
        .byte $b3,$b6,$b9,$bc,$bf,$c1,$c4,$c7
        .byte $c9,$cc,$ce,$d1,$d3,$d5,$d8,$da
        .byte $dc,$de,$e0,$e2,$e4,$e6,$e8,$ea
        .byte $ec,$ed,$ef,$f0,$f2,$f3,$f5,$f6
        .byte $f7,$f8,$f9,$fa,$fb,$fc,$fc,$fd
        .byte $fe,$fe,$ff,$ff,$ff,$ff,$ff,$ff
        .byte $ff,$ff,$ff,$ff,$ff,$fe,$fe,$fd
        .byte $fc,$fc,$fb,$fa,$f9,$f8,$f7,$f6
        .byte $f5,$f3,$f2,$f0,$ef,$ed,$ec,$ea
        .byte $e8,$e6,$e4,$e2,$e0,$de,$dc,$da
        .byte $d8,$d5,$d3,$d1,$ce,$cc,$c9,$c7
        .byte $c4,$c1,$bf,$bc,$b9,$b6,$b3,$b0
        .byte $ae,$ab,$a8,$a5,$a2,$9f,$9c,$98
        .byte $95,$92,$8f,$8c,$89,$86,$83,$80
* = $0b00
crdtsc  .byte $00,$09,$06,$0b,$02,$08,$04,$0c,$0e
        .byte $0a,$05,$0f,$03,$0d,$07,$01
* = $4b00
cncol	.byte $09,$06,$0b,$02,$08,$04,$0c,$0e
        .byte $0a,$05,$0f,$03,$0d,$07,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$07
        .byte $0d,$03,$0f,$05,$0a,$0e,$0c,$04
        .byte $08,$02,$0b,$06,$09,$09,$09,$09
.fill $20,$00        
* = $4a00
cncol1	.byte $09,$06,$0b,$02,$08,$04,$0c,$0e
        .byte $0a,$05,$0f,$03,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
        .byte $0d,$03,$0f,$05,$0a,$0e,$0c,$04
        .byte $08,$02,$0b,$06,$09,$09,$09,$09
* = $4800
clrcntab        
		.byte $01,$01,$07
        .byte $0d,$03,$0f,$05,$0a,$0e,$0c,$04
        .byte $08,$02,$0b,$06,$09,$00
* = $4f00
spdscroll        
		.byte $07,$07,$07,$06,$05,$04,$03,$02
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $01,$01,$01,$01,$01,$01,$01,$01
        .byte $02,$03,$04,$05,$06,$07,$07,$07